---
title: static
slug: Web/JavaScript/Reference/Classes/static
tags:
  - Classes
  - ECMAScript 2015
  - JavaScript
  - Language feature
  - Static
---
<div>{{jsSidebar("Classes")}}</div>

<p><span class="seoSummary">The <code><strong>static</strong></code> keyword defines a static method or property for a class. Neither static methods nor static properties can be called on instances of the class. Instead, they're called on the class itself.</span> Static methods are often utility functions, such as functions to create or clone objects, whereas static properties are useful for caches, fixed-configuration, or any other data you don't need to be replicated across instances.</p>

<div>{{EmbedInteractiveExample("pages/js/classes-static.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">static <var>methodName</var>() { ... }
static <var>propertyName </var>[= <var>value</var>];
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_static_members_in_classes">Using static members in classes</h3>

<p>The following example demonstrates several things:</p>

<ol>
 <li>How a static member (method or property) is defined on a class.</li>
 <li>That a class with a static member can be sub-classed.</li>
 <li>How a static member can and cannot be called.</li>
</ol>

<pre class="brush: js notranslate">class Triple {
  static customName = 'Tripler';
  static description = 'I triple any number you provide';
  static triple(n = 1) {
    return n * 3;
  }
}

class BiggerTriple extends Triple {
  static longDescription;
  static description = 'I square the triple of any number you provide';
  static triple(n) {
    return super.triple(n) * super.triple(n);
  }
}

console.log(Triple.description);   // 'I triple any number you provide'
console.log(Triple.triple());      // 3
console.log(Triple.triple(6));     // 18

var tp = new Triple();

console.log(BiggerTriple.triple(3));        // 81 (not affected by parent's instantiation)
console.log(BiggerTriple.description);      // 'I square the triple of any number you provide'
console.log(BiggerTriple.longDescription);  // undefined
console.log(BiggerTriple.customName);       // 'Tripler'

console.log(tp.triple());         // 'tp.triple is not a function'.
</pre>

<h3 id="Calling_static_members_from_another_static_method">Calling static members from another static method</h3>

<p>In order to call a static method or property within another static method of the same class, you can use the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this</a></code> keyword.</p>

<pre class="brush: js notranslate">class StaticMethodCall {
  static staticProperty = 'static property';
  static staticMethod() {
    return 'Static method and ' + this.staticProperty + ' has been called';
  }
  static anotherStaticMethod() {
    return this.staticMethod() + ' from another static method';
  }
}
StaticMethodCall.staticMethod();
// 'Static method and static property has been called'

StaticMethodCall.anotherStaticMethod();
// 'Static method and static property has been called from another static method'</pre>

<h3 id="Calling_static_members_from_a_class_constructor_and_other_methods">Calling static members from a class constructor and other methods</h3>

<p>Static members are not directly accessible using the {{jsxref("this")}} keyword from non-static methods. You need to call them using the class name: <code>CLASSNAME.STATIC_METHOD_NAME()</code> / <code>CLASSNAME.STATIC_PROPERTY_NAME</code> or by calling the method as a property of the <code>constructor</code>: <code>this.constructor.STATIC_METHOD_NAME() </code> / <code>this.constructor.STATIC_PROPERTY_NAME</code></p>

<pre class="brush: js notranslate">class StaticMethodCall {
  constructor() {
    console.log(StaticMethodCall.staticProperty); // 'static property'
    console.log(this.constructor.staticProperty); // 'static property'
    console.log(StaticMethodCall.staticMethod()); // 'static method has been called.'
    console.log(this.constructor.staticMethod()); // 'static method has been called.'
  }

  static staticProperty = 'static property';
  static staticMethod() {
    return 'static method has been called.';
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-class-definitions', 'Class definitions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.classes.static")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/class"><code>class</code> expression</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/class"><code>class</code> declaration</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Classes">Classes</a></li>
</ul>
